﻿using DemoProb.Classes;
using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Windows;
using System.Windows.Media.Imaging;

namespace DemoProb.WindowW
{
    /// <summary>
    /// Логика взаимодействия для AddWindow.xaml
    /// </summary>
    public partial class AddWindow : Window
    {
        List<string> listPathPhoto = new List<string>();
        int actualImage = -1;
        int status = 0;
        public AddWindow()
        {
            InitializeComponent();
            List<string> filesPapka = Directory.GetFiles("../Услуги школы/").ToList();
            foreach(string pathfile in filesPapka)
            {
                string tmp = pathfile.Replace("..", "");
                listPathPhoto.Add(tmp);
            }
        }

        private void SaveButton_Click(object sender, RoutedEventArgs e)
        {
            SaveChanges();
        }

        private void CancelButton_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void Right_Click(object sender, RoutedEventArgs e)
        {
            if(listPathPhoto.Count > 0)
            {
                if (actualImage != listPathPhoto.Count-1)
                    actualImage++;
                else actualImage = 0;
                ImageService.Source = new BitmapImage(new Uri (listPathPhoto[actualImage], UriKind.Relative));
            }
            else MessageBox.Show("Нет фото", "ошибка", MessageBoxButton.OK, MessageBoxImage.Warning);
        }

        private void Left_Click(object sender, RoutedEventArgs e)
        {
            if (listPathPhoto.Count > 0)
            {
                if (actualImage > 0)
                    actualImage--;
                else actualImage = listPathPhoto.Count-1;
                ImageService.Source = new BitmapImage(new Uri(listPathPhoto[actualImage], UriKind.Relative));
            }
            else MessageBox.Show("Нет фото", "ошибка", MessageBoxButton.OK, MessageBoxImage.Warning);
        }

        private void Window_Closed(object sender, EventArgs e)
        {
            if(status == 0)
            {
                MessageBoxResult res = MessageBox.Show("Остались несохраненные изменения. Сохранить?", "Предупреждение", MessageBoxButton.YesNo, MessageBoxImage.Warning);
                switch (res)
                {
                    case MessageBoxResult.Yes:
                        {
                            SaveChanges();
                        }
                        break;
                    case MessageBoxResult.No:
                        this.Close();
                        break;
                }
            }
        }
        private void SaveChanges()
        {
            try
            {
                List<Service> listService = BaseClass.BaseSchool.Service.ToList();
                int count = 0;
                foreach (Service service in listService)
                {
                    if (service.Title == TitleService.Text)
                    {
                        MessageBox.Show("Такая услуга уже существует", "Ошибка", MessageBoxButton.OK, MessageBoxImage.Error);
                        count++;
                        break;
                    }
                }
                if (count == 0)
                {
                    if (TitleService.Text.Length < 1)
                    {
                        MessageBox.Show("Заполните поле \"Название\"", "Изменения не сохранены", MessageBoxButton.OK, MessageBoxImage.Error);
                    }
                    else if (CostService.Text.Length < 1)
                    {
                        MessageBox.Show("Заполните поле \"Цена\"", "Изменения не сохранены", MessageBoxButton.OK, MessageBoxImage.Error);
                    }
                    else if (DurationService.Text.Length < 1)
                    {
                        MessageBox.Show("Заполните поле \"Длительность (мин)\"", "Изменения не сохранены", MessageBoxButton.OK, MessageBoxImage.Error);
                    }
                    else
                    {
                        Service service = new Service();
                        service.Title = TitleService.Text;
                        service.Cost = Convert.ToInt32(CostService.Text);
                        if (DiscountService.Text.Length > 0)
                            service.Discount = Convert.ToDouble(DiscountService.Text) / 100;
                        else service.Discount = null;
                        service.DurationInSeconds = Convert.ToInt32(Convert.ToDouble(DurationService.Text) * 60);
                        service.Description = DescriptService.Text;
                        service.MainImagePath = listPathPhoto[actualImage];
                        BaseClass.BaseSchool.Service.Add(service);
                        BaseClass.BaseSchool.SaveChanges();
                        MessageBox.Show("Изменения сохранены", "Уведомление", MessageBoxButton.OK, MessageBoxImage.Information);
                        status = 1;

                        this.Close();
                    }
                }
            }
            catch
            {
                MessageBox.Show("Неудалось сохранить", "Уведомление", MessageBoxButton.OK, MessageBoxImage.Information);
            }
        }
    }
}
