﻿using DemoProb.Classes;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Windows;
using System.Windows.Media.Imaging;

namespace DemoProb.WindowW
{
    /// <summary>
    /// Логика взаимодействия для CreateWindow.xaml
    /// </summary>
    public partial class CreateWindow : Window
    {
        Service serviceItem = new Service();
        List<string> listPathPhoto = new List<string>();
        int actualImage = -1;
        public CreateWindow(Service itemCreate)
        {
            InitializeComponent();

            List<string> filesPapka = Directory.GetFiles("../Услуги школы/").ToList();
            foreach (string pathfile in filesPapka)
            {
                string tmp = pathfile.Replace("..", "");
                listPathPhoto.Add(tmp);
            }

            serviceItem = itemCreate;
            TitleService.Text = itemCreate.Title;
            CostService.Text = Convert.ToInt32(itemCreate.Cost).ToString();
            if (itemCreate.Discount != null)
                DiscountService.Text = (itemCreate.Discount * 100).ToString();
            DurationService.Text = Convert.ToInt32((double)(itemCreate.DurationInSeconds) / 60).ToString();
            ImageService.Source = new BitmapImage(new Uri(serviceItem.MainImagePath, UriKind.Relative));
        }

        private void CancelButton_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void SaveButton_Click(object sender, RoutedEventArgs e)
        {
            SaveChanges();
        }

        private void Window_Closed(object sender, EventArgs e)
        {
            if (TitleService.Text != serviceItem.Title || CostService.Text != Convert.ToInt32(serviceItem.Cost).ToString() || DurationService.Text != Convert.ToInt32((double)(serviceItem.DurationInSeconds) / 60).ToString())
            {
                MessageBoxResult res = MessageBox.Show("Остались несохраненные изменения. Сохранить?", "Предупреждение", MessageBoxButton.YesNo, MessageBoxImage.Warning);
                switch (res)
                {
                    case MessageBoxResult.Yes:
                        {
                            SaveChanges();
                        }
                        break;
                    case MessageBoxResult.No:
                        this.Close();
                        break;
                }
            }

        }
        private void SaveChanges()
        {
            try
            {
                Service create = BaseClass.BaseSchool.Service.FirstOrDefault(x => x.ID == serviceItem.ID);
                create.Title = TitleService.Text;
                create.Cost = Convert.ToInt32(CostService.Text);
                if (DiscountService.Text.Length > 0)
                    create.Discount = Convert.ToDouble(DiscountService.Text) / 100;
                else create.Discount = null;
                create.MainImagePath = listPathPhoto[actualImage];
                create.DurationInSeconds = Convert.ToInt32(Convert.ToDouble(DurationService.Text) * 60);
                BaseClass.BaseSchool.SaveChanges();
                MessageBox.Show("Изменения сохранены", "Уведомление", MessageBoxButton.OK, MessageBoxImage.Information);
                this.Close();
            }
            catch
            {
                MessageBox.Show("Неудалось сохранить изменения", "Уведомление", MessageBoxButton.OK, MessageBoxImage.Information);
            }
        }

        private void Right_Click(object sender, RoutedEventArgs e)
        {
            if (listPathPhoto.Count > 0)
            {
                if (actualImage != listPathPhoto.Count - 1)
                    actualImage++;
                else actualImage = 0;
                ImageService.Source = new BitmapImage(new Uri(listPathPhoto[actualImage], UriKind.Relative));
            }
            else MessageBox.Show("Нет фото", "ошибка", MessageBoxButton.OK, MessageBoxImage.Warning);
        }

        private void Left_Click(object sender, RoutedEventArgs e)
        {
            if (listPathPhoto.Count > 0)
            {
                if (actualImage > 0)
                    actualImage--;
                else actualImage = listPathPhoto.Count - 1;
                ImageService.Source = new BitmapImage(new Uri(listPathPhoto[actualImage], UriKind.Relative));
            }
            else MessageBox.Show("Нет фото", "ошибка", MessageBoxButton.OK, MessageBoxImage.Warning);
        }
    }
}
