﻿using DemoProb.Classes;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace DemoProb.WindowW
{
    /// <summary>
    /// Логика взаимодействия для RecordForService.xaml
    /// </summary>
    public partial class RecordForService : Window
    {
        Service service = new Service();
        List<Client> clients = BaseClass.BaseSchool.Client.ToList();
        Client client = new Client();
        int hourEnd, minutesEnd;
        public RecordForService(string uId)
        {
            InitializeComponent();
            ListClient.ItemsSource = clients;
            service = BaseClass.BaseSchool.Service.FirstOrDefault(x => x.ID.ToString() == uId);
            TitleService.Text += $"{service.Title}";
            if(service.Discount == null || service.Discount == 0)
            CostService.Text += $"{Convert.ToInt32(service.Cost)} р.";
            else CostService.Text += $"{(int)((double)service.Cost - ((double)service.Cost * service.Discount))} р.";
            DurationService.Text += $"{Convert.ToInt32(service.DurationInSeconds/60)} минут";
        }

        private void Timer_Tick(object sender, EventArgs e)
        {
            ListClient.ItemsSource = null;
        }

        private void ListClient_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            client = (Client)(ListClient.SelectedItem);
            ClientName.Text = $"{client.LastName} {client.FirstName} {client.Patronymic}";
        }

        private void clockTimeStart_TextChanged(object sender, TextChangedEventArgs e)
        {
            try
            {
                if (clockTimeStart.Text != string.Empty || minTimeStart.Text != string.Empty)
                {
                    if (Convert.ToInt32(clockTimeStart.Text) >= 24 || Convert.ToInt32(minTimeStart.Text) >= 60) MessageBox.Show("Неверная дата", "Ошибка", MessageBoxButton.OK, MessageBoxImage.Error);
                    else
                    {
                        int hour = service.DurationInSeconds / 3600, minutes = (service.DurationInSeconds - hour * 3600) / 60;
                        hourEnd = Convert.ToInt32(clockTimeStart.Text) + hour;
                        minutesEnd = Convert.ToInt32(minTimeStart.Text) + minutes;
                        if (minutesEnd >= 60)
                        {
                            hourEnd += 1;
                            minutesEnd -= 60;
                        }
                        if (hourEnd >= 24)
                        {
                            hourEnd -= 24;
                        }
                        clockTimeEnd.Text = $"{hourEnd}:{minutesEnd}";
                    }
                }
            }
            catch { }
        }

        private void CancelButton_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        private void SaveButton_Click(object sender, RoutedEventArgs e)
        {
            Regex emailRegex = new Regex(@"^[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,}$");
            Regex phoneRegex = new Regex("^\\+?[1-9][0-9]{8,14}$");

            if (emailRegex.IsMatch(Email.Text) == false)
                MessageBox.Show("Введена некорректная почта", "Ошибка", MessageBoxButton.OK, MessageBoxImage.Error);
            else if (Convert.ToInt32(clockTimeStart.Text) >= 24 || Convert.ToInt32(minTimeStart.Text) >= 60) 
                MessageBox.Show("Указано неверное время", "Ошибка", MessageBoxButton.OK, MessageBoxImage.Error);
            else if ((Convert.ToInt32(clockTimeStart.Text) > 18 || Convert.ToInt32(clockTimeStart.Text) < 9) || (Convert.ToInt32(hourEnd) >= 18 && Convert.ToInt32(minutesEnd) > 00))
                MessageBox.Show("Рабочий день с 9 до 18. Укажите время, согласно графику работы.", "Ошибка", MessageBoxButton.OK, MessageBoxImage.Error);
            else if (ClientName.Text == "не выбран")
                MessageBox.Show("Клиент не выбран", "Ошибка", MessageBoxButton.OK, MessageBoxImage.Error);
            else if (Calendar.SelectedDate == null)
                MessageBox.Show("Выбрана неверная дата", "Ошибка", MessageBoxButton.OK, MessageBoxImage.Error);
            else if (Calendar.SelectedDate == DateTime.Now)
                MessageBox.Show("На сегодня записаться нельзя", "Ошибка", MessageBoxButton.OK, MessageBoxImage.Error);
            else if (phoneRegex.IsMatch(PhoneNumber.Text) == false)
                MessageBox.Show("Введен некорректный номер", "Ошибка", MessageBoxButton.OK, MessageBoxImage.Error);
            else
            {
                string[] bt = (Calendar.SelectedDate.ToString()).Split(new char[] {'.'});
                string[] bt2 = bt[2].Split(new char[] { ' ' });
                ClientService clientService = new ClientService()
                {
                    ClientID = client.ID,
                    ServiceID = service.ID,
                    StartTime = new DateTime(Convert.ToInt32(bt2[0]), Convert.ToInt32(bt[1]), Convert.ToInt32(bt[0]), Convert.ToInt32(clockTimeStart.Text), Convert.ToInt32(minTimeStart.Text), 00),
                    Comment = Email.Text + "," + PhoneNumber.Text
                };
                BaseClass.BaseSchool.ClientService.Add(clientService);
                BaseClass.BaseSchool.SaveChanges();
                MessageBox.Show("Запись добавлена", "Уведомление", MessageBoxButton.OK, MessageBoxImage.Information);
                Close();
            }
        }
    }
}
