﻿using DemoProb.Classes;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace DemoProb.WindowW
{
    /// <summary>
    /// 
    /// </summary>
    public partial class UpcomingEntries : Window
    {
        List<ClientService> clientServices = BaseClass.BaseSchool.ClientService.ToList();
        DispatcherTimer timer = new DispatcherTimer();

        public UpcomingEntries()
        {
            InitializeComponent();
            timer.Start();
            timer.Interval = new TimeSpan(0, 0, 10);
            timer.Tick += Timer_Tick; ;

            ListClientService.ItemsSource = clientServices.OrderBy(x=>x.StartTime).Reverse();
        }

        private void Timer_Tick(object sender, EventArgs e)
        {
            clientServices = BaseClass.BaseSchool.ClientService.ToList();
            ListClientService.ItemsSource = null;
            ListClientService.ItemsSource = clientServices.OrderBy(x => x.StartTime).Reverse();
            MessageBox.Show("update");
            timer.Start();
        }

        private void Email_Loaded(object sender, RoutedEventArgs e)
        {
            TextBlock tbEmail = (TextBlock)sender;
            ClientService clientService = BaseClass.BaseSchool.ClientService.FirstOrDefault(x => x.ID.ToString() == tbEmail.Uid);
            if (clientService.Comment != null)
            {
                string[] strings = (clientService.Comment).Split(new char[] { ',' });
                tbEmail.Text = strings[0];
            }
            else tbEmail.Text = "Не указан";
        }

        private void PhoneNumber_Loaded(object sender, RoutedEventArgs e)
        {
            TextBlock tbPhone = (TextBlock)sender;
            ClientService clientService = BaseClass.BaseSchool.ClientService.FirstOrDefault(x => x.ID.ToString() == tbPhone.Uid);
            if (clientService.Comment != null)
            {
                string[] strings = (clientService.Comment).Split(new char[] { ',' });
                tbPhone.Text = strings[1];
            }
            else tbPhone.Text = "Не указан";
        }

        private void TimeForStart_Loaded(object sender, RoutedEventArgs e)
        {
            TextBlock tbTime = (TextBlock)sender;
            ClientService clientService = BaseClass.BaseSchool.ClientService.FirstOrDefault(x => x.ID.ToString() == tbTime.Uid);
            if(clientService != null)
            {
                if (clientService.StartTime > DateTime.Now)
                {
                    TimeSpan dtime = clientService.StartTime - DateTime.Now;
                    tbTime.Text = $"{dtime.Days} дней {dtime.Hours} часов {dtime.Minutes} минут";
                }
                else tbTime.Text = "Запись окончена";
            }
            else tbTime.Text = "Не найдено";
        }

        private void Grid_Loaded(object sender, RoutedEventArgs e)
        {
            Grid grid = (Grid)sender;
            ClientService clientService = BaseClass.BaseSchool.ClientService.FirstOrDefault(x => x.ID.ToString() == grid.Uid);
            TimeSpan time = new TimeSpan(01, 00, 00);
            if (clientService.StartTime - DateTime.Now < time && clientService.StartTime > DateTime.Now) grid.Background = new SolidColorBrush(Colors.IndianRed);
            else if(clientService.StartTime <= DateTime.Now && clientService.StartTime - DateTime.Now < time) grid.Background = (Brush)(new BrushConverter().ConvertFrom("#FFE7FABF"));
        }
    }
}
